//
// WebLinkCollection.cs
//
// Author:
//       Carsten Sonne Larsen <cs@innolan.dk>
//
// Copyright (c) 2013-2016 Carsten Sonne Larsen
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Ntp.Analyzer.Export;
using Ntp.Analyzer.Localize;
using Ntp.Config;

namespace Ntp.Analyzer.Config.Destination
{
    public sealed class WebLinkCollection : ConfigurationBase, IEnumerable<WebLink>
    {
        private WebLinkCollection(
            string configName,
            int indentLevel,
            IList<WebLink> links)
            : base(configName, indentLevel)
        {
            this.links = links;
        }

        public const string Identifier = ConfigurationKeyword.WebLinks;
        private readonly IList<WebLink> links;

        protected override IEnumerable<object> Items
        {
            get { return Destinations; }
        }

        public IList<WebLink> Destinations
        {
            get { return links; }
        }

        public IEnumerator<WebLink> GetEnumerator()
        {
            return Destinations.GetEnumerator();
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }

        public override string ToString()
        {
            var values = new List<Object> {null};
            IEnumerable<String> names = Destinations.Select(l => l.Link);
            values.AddRange(names);

            var settings = new List<String> {Identifier};

            int num = links.Count();
            for (int i = 0; i < num; i++)
                settings.Add(ConfigurationKeyword.WebLinkItem);

            return ConfigText(settings.ToArray(), values.ToArray());
        }

        public static WebLinkCollection Create(
            HostConfiguration server,
            ConfigurationBlock config)
        {
            var links = new List<WebLink>();
            ConfigurationBlock linkBlock = FindSingleBlock(Identifier, config);

            if (linkBlock == null)
                return new WebLinkCollection(String.Empty, config.IndentLevel + 1, links);

            foreach (string link in GetMultiOption(ConfigurationKeyword.WebLinkItem, linkBlock))
                links.Add(new WebLink(link));

            return new WebLinkCollection(String.Empty, config.IndentLevel + 1, links);
        }

        public static WebLinkCollection Create(int indentLevel, string link)
        {
            return new WebLinkCollection(
                String.Empty,
                indentLevel + 1,
                new List<WebLink> {new WebLink(link)}
                );
        }
    }
}